Index: src/arch/i386/lib/console_print.c
===================================================================
--- /dev/null
+++ src/arch/i386/lib/console_print.c
@@ -0,0 +1,115 @@
+
+static void __console_tx_nibble(unsigned nibble)
+{
+	unsigned char digit;
+	digit = nibble + '0';
+	if (digit > '9') {
+		digit += 39;
+	}
+	__console_tx_byte(digit);
+}
+
+static void __console_tx_char(int loglevel, unsigned char byte)
+{
+	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
+		__console_tx_byte(byte);
+	}
+}
+
+static void __console_tx_hex8(int loglevel, unsigned char value)
+{
+	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
+		__console_tx_nibble((value >>  4U) & 0x0fU);
+		__console_tx_nibble(value & 0x0fU);
+	}
+}
+
+static void __console_tx_hex16(int loglevel, unsigned short value)
+{
+	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
+		__console_tx_nibble((value >> 12U) & 0x0fU);
+		__console_tx_nibble((value >>  8U) & 0x0fU);
+		__console_tx_nibble((value >>  4U) & 0x0fU);
+		__console_tx_nibble(value & 0x0fU);
+	}
+}
+
+static void __console_tx_hex32(int loglevel, unsigned int value)
+{
+	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
+		__console_tx_nibble((value >> 28U) & 0x0fU);
+		__console_tx_nibble((value >> 24U) & 0x0fU);
+		__console_tx_nibble((value >> 20U) & 0x0fU);
+		__console_tx_nibble((value >> 16U) & 0x0fU);
+		__console_tx_nibble((value >> 12U) & 0x0fU);
+		__console_tx_nibble((value >>  8U) & 0x0fU);
+		__console_tx_nibble((value >>  4U) & 0x0fU);
+		__console_tx_nibble(value & 0x0fU);
+	}
+}
+
+static void __console_tx_string(int loglevel, const char *str)
+{
+	if (ASM_CONSOLE_LOGLEVEL > loglevel) {
+		unsigned char ch;
+		while((ch = *str++) != '\0') {
+			__console_tx_byte(ch);
+		}
+	}
+}
+
+#define NOINLINE __attribute__((noinline))
+static void print_emerg_char(unsigned char byte) { __console_tx_char(BIOS_EMERG, byte); }
+static void print_emerg_hex8(unsigned char value){ __console_tx_hex8(BIOS_EMERG, value); }
+static void print_emerg_hex16(unsigned short value){ __console_tx_hex16(BIOS_EMERG, value); }
+static void print_emerg_hex32(unsigned int value) { __console_tx_hex32(BIOS_EMERG, value); }
+static void print_emerg(const char *str) { __console_tx_string(BIOS_EMERG, str); }
+
+static void print_alert_char(unsigned char byte) { __console_tx_char(BIOS_ALERT, byte); }
+static void print_alert_hex8(unsigned char value) { __console_tx_hex8(BIOS_ALERT, value); }
+static void print_alert_hex16(unsigned short value){ __console_tx_hex16(BIOS_ALERT, value); }
+static void print_alert_hex32(unsigned int value) { __console_tx_hex32(BIOS_ALERT, value); }
+static void print_alert(const char *str) { __console_tx_string(BIOS_ALERT, str); }
+
+static void print_crit_char(unsigned char byte) { __console_tx_char(BIOS_CRIT, byte); }
+static void print_crit_hex8(unsigned char value) { __console_tx_hex8(BIOS_CRIT, value); }
+static void print_crit_hex16(unsigned short value){ __console_tx_hex16(BIOS_CRIT, value); }
+static void print_crit_hex32(unsigned int value) { __console_tx_hex32(BIOS_CRIT, value); }
+static void print_crit(const char *str) { __console_tx_string(BIOS_CRIT, str); }
+
+static void print_err_char(unsigned char byte) { __console_tx_char(BIOS_ERR, byte); }
+static void print_err_hex8(unsigned char value) { __console_tx_hex8(BIOS_ERR, value); }
+static void print_err_hex16(unsigned short value){ __console_tx_hex16(BIOS_ERR, value); }
+static void print_err_hex32(unsigned int value) { __console_tx_hex32(BIOS_ERR, value); }
+static void print_err(const char *str) { __console_tx_string(BIOS_ERR, str); }
+
+static void print_warning_char(unsigned char byte) { __console_tx_char(BIOS_WARNING, byte); }
+static void print_warning_hex8(unsigned char value) { __console_tx_hex8(BIOS_WARNING, value); }
+static void print_warning_hex16(unsigned short value){ __console_tx_hex16(BIOS_WARNING, value); }
+static void print_warning_hex32(unsigned int value) { __console_tx_hex32(BIOS_WARNING, value); }
+static void print_warning(const char *str) { __console_tx_string(BIOS_WARNING, str); }
+
+static void print_notice_char(unsigned char byte) { __console_tx_char(BIOS_NOTICE, byte); }
+static void print_notice_hex8(unsigned char value) { __console_tx_hex8(BIOS_NOTICE, value); }
+static void print_notice_hex16(unsigned short value){ __console_tx_hex16(BIOS_NOTICE, value); }
+static void print_notice_hex32(unsigned int value) { __console_tx_hex32(BIOS_NOTICE, value); }
+static void print_notice(const char *str) { __console_tx_string(BIOS_NOTICE, str); }
+
+static void print_info_char(unsigned char byte) { __console_tx_char(BIOS_INFO, byte); }
+static void print_info_hex8(unsigned char value) { __console_tx_hex8(BIOS_INFO, value); }
+static void print_info_hex16(unsigned short value){ __console_tx_hex16(BIOS_INFO, value); }
+static void print_info_hex32(unsigned int value) { __console_tx_hex32(BIOS_INFO, value); }
+static void print_info(const char *str) { __console_tx_string(BIOS_INFO, str); }
+
+static void print_debug_char(unsigned char byte) { __console_tx_char(BIOS_DEBUG, byte); }
+static void print_debug_hex8(unsigned char value) { __console_tx_hex8(BIOS_DEBUG, value); }
+static void print_debug_hex16(unsigned short value){ __console_tx_hex16(BIOS_DEBUG, value); }
+static void print_debug_hex32(unsigned int value) { __console_tx_hex32(BIOS_DEBUG, value); }
+static void print_debug(const char *str) { __console_tx_string(BIOS_DEBUG, str); }
+
+static void print_spew_char(unsigned char byte) { __console_tx_char(BIOS_SPEW, byte); }
+static void print_spew_hex8(unsigned char value) { __console_tx_hex8(BIOS_SPEW, value); }
+static void print_spew_hex16(unsigned short value){ __console_tx_hex16(BIOS_SPEW, value); }
+static void print_spew_hex32(unsigned int value) { __console_tx_hex32(BIOS_SPEW, value); }
+static void print_spew(const char *str) { __console_tx_string(BIOS_SPEW, str); }
+
Index: src/arch/i386/lib/c_start.S
===================================================================
--- src/arch/i386/lib/c_start.S.orig
+++ src/arch/i386/lib/c_start.S
@@ -263,9 +263,9 @@ gdt:
 	.word	0x0000, 0x0000		/* dummy */
 	.byte	0x00, 0x00, 0x00, 0x00
 
-	/* selgdt 0x10, flat code segment */
+	/* selgdt 0x10, flat code segment */ 
 	.word	0xffff, 0x0000		
-	.byte	0x00, 0x9b, 0xcf, 0x00	
+	.byte	0x00, 0x9b, 0xcf, 0x00 /* G=1 and 0x0f, So we get 4Gbytes for limit */	
 
 	/* selgdt 0x18, flat data segment */
 	.word	0xffff, 0x0000		
Index: src/arch/i386/lib/Config.lb
===================================================================
--- src/arch/i386/lib/Config.lb.orig
+++ src/arch/i386/lib/Config.lb
@@ -1,6 +1,3 @@
-uses CONFIG_USE_INIT
-uses CONFIG_USE_PRINTK_IN_CAR
-
 object c_start.S
 object cpu.c
 object pci_ops_conf1.c
@@ -9,9 +6,3 @@ object pci_ops_mmconf.c
 object pci_ops_auto.c
 object exception.c
 
-if CONFIG_USE_INIT
-	if CONFIG_USE_PRINTK_IN_CAR
-		initobject printk_init.o
-	end
-end
-
Index: src/arch/i386/lib/cpu.c
===================================================================
--- src/arch/i386/lib/cpu.c.orig
+++ src/arch/i386/lib/cpu.c
@@ -207,7 +207,6 @@ static void set_cpu_ops(struct device *c
 			}
 		}
 	}
-	die("Unknown cpu");
 	return;
  found:
 	cpu->ops = driver->ops;
@@ -223,7 +222,7 @@ void cpu_initialize(void)
 	struct device *cpu;
 	struct cpu_info *info;
 	struct cpuinfo_x86 c;
-
+	
 	info = cpu_info();
 
 	printk_notice("Initializing CPU #%d\n", info->index);
@@ -233,41 +232,37 @@ void cpu_initialize(void)
 		die("CPU: missing cpu device structure");
 	}
 
-	// Check that we haven't been passed bad information as the result of a race 
-	// (i.e. BSP timed out while waiting for us to load secondary_stack)
-
-#if CONFIG_SMP  || CONFIG_IOPIC 
-	if (cpu->path.u.apic.apic_id != lapicid()) {
-		printk_err("CPU #%d Initialization FAILED: APIC ID mismatch (%u != %u)\n",
-				   info->index, cpu->path.u.apic.apic_id, lapicid());
-		// return without setting initialized flag
-	} else {
-#endif
-		/* Find what type of cpu we are dealing with */
-		identify_cpu(cpu);
-		printk_debug("CPU: vendor %s device %x\n",
-			cpu_vendor_name(cpu->vendor), cpu->device);
-
-	        get_fms(&c, cpu->device);
-
-	        printk_debug("CPU: family %02x, model %02x, stepping %02x\n", c.x86, c.x86_model, c.x86_mask);
-
-			
-		/* Lookup the cpu's operations */
+	/* Find what type of cpu we are dealing with */
+	identify_cpu(cpu);
+	printk_debug("CPU: vendor %s device %x\n",
+		cpu_vendor_name(cpu->vendor), cpu->device);
+
+	get_fms(&c, cpu->device);
+
+	printk_debug("CPU: family %02x, model %02x, stepping %02x\n", c.x86, c.x86_model, c.x86_mask);
+	
+	/* Lookup the cpu's operations */
+	set_cpu_ops(cpu);
+
+	if(!cpu->ops) { 
+		/* mask out the stepping and try again */
+		cpu->device -= c.x86_mask;
 		set_cpu_ops(cpu);
+		cpu->device += c.x86_mask;
+		if(!cpu->ops) die("Unknown cpu");
+		printk_debug("Using stepping 0 ops instead\n");
+	}
+	
 
-		/* Initialize the cpu */
-		if (cpu->ops && cpu->ops->init) {
-			cpu->enabled = 1;
-			cpu->initialized = 1;
-			cpu->ops->init(cpu);
-		}
+	/* Initialize the cpu */
+	if (cpu->ops && cpu->ops->init) {
+		cpu->enabled = 1;
+		cpu->initialized = 1;
+		cpu->ops->init(cpu);
+	}
 
-		printk_info("CPU #%d Initialized\n", info->index);
-#if CONFIG_SMP  || CONFIG_IOPIC 
+	printk_info("CPU #%d Initialized\n", info->index);
 
-	}
-#endif
 	return;
 }
 
Index: src/arch/i386/lib/console_printk_ram.c
===================================================================
--- /dev/null
+++ src/arch/i386/lib/console_printk_ram.c
@@ -0,0 +1,120 @@
+#if CONFIG_USBDEBUG_DIRECT
+
+extern int do_printk_ram(int msg_level, const char *fmt, ...);
+
+#define printk_ram_emerg(fmt, arg...)   do_printk_ram(BIOS_EMERG   ,fmt, ##arg)
+#define printk_ram_alert(fmt, arg...)   do_printk_ram(BIOS_ALERT   ,fmt, ##arg)
+#define printk_ram_crit(fmt, arg...)    do_printk_ram(BIOS_CRIT    ,fmt, ##arg)
+#define printk_ram_err(fmt, arg...)     do_printk_ram(BIOS_ERR     ,fmt, ##arg)
+#define printk_ram_warning(fmt, arg...) do_printk_ram(BIOS_WARNING ,fmt, ##arg)
+#define printk_ram_notice(fmt, arg...)  do_printk_ram(BIOS_NOTICE  ,fmt, ##arg)
+#define printk_ram_info(fmt, arg...)    do_printk_ram(BIOS_INFO    ,fmt, ##arg)
+#define printk_ram_debug(fmt, arg...)   do_printk_ram(BIOS_DEBUG   ,fmt, ##arg)
+#define printk_ram_spew(fmt, arg...)    do_printk_ram(BIOS_SPEW    ,fmt, ##arg)
+
+#else
+
+#define printk_ram_emerg(fmt, arg...)   do_printk(BIOS_EMERG   ,fmt, ##arg)
+#define printk_ram_alert(fmt, arg...)   do_printk(BIOS_ALERT   ,fmt, ##arg)
+#define printk_ram_crit(fmt, arg...)    do_printk(BIOS_CRIT    ,fmt, ##arg)
+#define printk_ram_err(fmt, arg...)     do_printk(BIOS_ERR     ,fmt, ##arg)
+#define printk_ram_warning(fmt, arg...) do_printk(BIOS_WARNING ,fmt, ##arg)
+#define printk_ram_notice(fmt, arg...)  do_printk(BIOS_NOTICE  ,fmt, ##arg)
+#define printk_ram_info(fmt, arg...)    do_printk(BIOS_INFO    ,fmt, ##arg)
+#define printk_ram_debug(fmt, arg...)   do_printk(BIOS_DEBUG   ,fmt, ##arg)
+#define printk_ram_spew(fmt, arg...)    do_printk(BIOS_SPEW    ,fmt, ##arg)
+
+#endif
+
+
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_EMERG
+#undef  printk_ram_emerg
+#define printk_ram_emerg(fmt, arg...)   do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_ALERT
+#undef  printk_ram_alert
+#define printk_ram_alert(fmt, arg...)   do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_CRIT
+#undef  printk_ram_crit
+#define printk_ram_crit(fmt, arg...)    do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_ERR
+#undef  printk_ram_err
+#define printk_ram_err(fmt, arg...)     do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_WARNING
+#undef  printk_ram_warning
+#define printk_ram_warning(fmt, arg...) do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_NOTICE
+#undef  printk_ram_notice
+#define printk_ram_notice(fmt, arg...)  do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_INFO
+#undef  printk_ram_info
+#define printk_ram_info(fmt, arg...)    do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_DEBUG
+#undef  printk_ram_debug
+#define printk_ram_debug(fmt, arg...)   do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_SPEW
+#undef  printk_ram_spew
+#define printk_ram_spew(fmt, arg...)    do {} while(0)
+#endif
+
+#if CONFIG_USBDEBUG_DIRECT
+
+#define print_ram_emerg(STR)   printk_ram_emerg  ("%s", (STR))
+#define print_ram_alert(STR)   printk_ram_alert  ("%s", (STR))
+#define print_ram_crit(STR)    printk_ram_crit   ("%s", (STR))
+#define print_ram_err(STR)     printk_ram_err    ("%s", (STR))
+#define print_ram_warning(STR) printk_ram_warning("%s", (STR))
+#define print_ram_notice(STR)  printk_ram_notice ("%s", (STR))
+#define print_ram_info(STR)    printk_ram_info   ("%s", (STR))
+#define print_ram_debug(STR)   printk_ram_debug  ("%s", (STR))
+#define print_ram_spew(STR)    printk_ram_spew   ("%s", (STR))
+
+#define print_ram_emerg_char(CH)   printk_ram_emerg  ("%c", (CH))
+#define print_ram_alert_char(CH)   printk_ram_alert  ("%c", (CH))
+#define print_ram_crit_char(CH)    printk_ram_crit   ("%c", (CH))
+#define print_ram_err_char(CH)     printk_ram_err    ("%c", (CH))
+#define print_ram_warning_char(CH) printk_ram_warning("%c", (CH))
+#define print_ram_notice_char(CH)  printk_ram_notice ("%c", (CH))
+#define print_ram_info_char(CH)    printk_ram_info   ("%c", (CH))
+#define print_ram_debug_char(CH)   printk_ram_debug  ("%c", (CH))
+#define print_ram_spew_char(CH)    printk_ram_spew   ("%c", (CH))
+
+#define print_ram_emerg_hex8(HEX)   printk_ram_emerg  ("%02x",  (HEX))
+#define print_ram_alert_hex8(HEX)   printk_ram_alert  ("%02x",  (HEX))
+#define print_ram_crit_hex8(HEX)    printk_ram_crit   ("%02x",  (HEX))
+#define print_ram_err_hex8(HEX)     printk_ram_err    ("%02x",  (HEX))
+#define print_ram_warning_hex8(HEX) printk_ram_warning("%02x",  (HEX))
+#define print_ram_notice_hex8(HEX)  printk_ram_notice ("%02x",  (HEX))
+#define print_ram_info_hex8(HEX)    printk_ram_info   ("%02x",  (HEX))
+#define print_ram_debug_hex8(HEX)   printk_ram_debug  ("%02x",  (HEX))
+#define print_ram_spew_hex8(HEX)    printk_ram_spew   ("%02x",  (HEX))
+
+#define print_ram_emerg_hex16(HEX)   printk_ram_emerg  ("%04x", (HEX))
+#define print_ram_alert_hex16(HEX)   printk_ram_alert  ("%04x", (HEX))
+#define print_ram_crit_hex16(HEX)    printk_ram_crit   ("%04x", (HEX))
+#define print_ram_err_hex16(HEX)     printk_ram_err    ("%04x", (HEX))
+#define print_ram_warning_hex16(HEX) printk_ram_warning("%04x", (HEX))
+#define print_ram_notice_hex16(HEX)  printk_ram_notice ("%04x", (HEX))
+#define print_ram_info_hex16(HEX)    printk_ram_info   ("%04x", (HEX))
+#define print_ram_debug_hex16(HEX)   printk_ram_debug  ("%04x", (HEX))
+#define print_ram_spew_hex16(HEX)    printk_ram_spew   ("%04x", (HEX))
+
+#define print_ram_emerg_hex32(HEX)   printk_ram_emerg  ("%08x", (HEX))
+#define print_ram_alert_hex32(HEX)   printk_ram_alert  ("%08x", (HEX))
+#define print_ram_crit_hex32(HEX)    printk_ram_crit   ("%08x", (HEX))
+#define print_ram_err_hex32(HEX)     printk_ram_err    ("%08x", (HEX))
+#define print_ram_warning_hex32(HEX) printk_ram_warning("%08x", (HEX))
+#define print_ram_notice_hex32(HEX)  printk_ram_notice ("%08x", (HEX))
+#define print_ram_info_hex32(HEX)    printk_ram_info   ("%08x", (HEX))
+#define print_ram_debug_hex32(HEX)   printk_ram_debug  ("%08x", (HEX))
+#define print_ram_spew_hex32(HEX)    printk_ram_spew   ("%08x", (HEX))
+
+#endif
+
Index: src/arch/i386/lib/console_printk.c
===================================================================
--- /dev/null
+++ src/arch/i386/lib/console_printk.c
@@ -0,0 +1,101 @@
+
+extern int do_printk(int msg_level, const char *fmt, ...);
+
+#define printk_emerg(fmt, arg...)   do_printk(BIOS_EMERG   ,fmt, ##arg)
+#define printk_alert(fmt, arg...)   do_printk(BIOS_ALERT   ,fmt, ##arg)
+#define printk_crit(fmt, arg...)    do_printk(BIOS_CRIT    ,fmt, ##arg)
+#define printk_err(fmt, arg...)     do_printk(BIOS_ERR     ,fmt, ##arg)
+#define printk_warning(fmt, arg...) do_printk(BIOS_WARNING ,fmt, ##arg)
+#define printk_notice(fmt, arg...)  do_printk(BIOS_NOTICE  ,fmt, ##arg)
+#define printk_info(fmt, arg...)    do_printk(BIOS_INFO    ,fmt, ##arg)
+#define printk_debug(fmt, arg...)   do_printk(BIOS_DEBUG   ,fmt, ##arg)
+#define printk_spew(fmt, arg...)    do_printk(BIOS_SPEW    ,fmt, ##arg)
+
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_EMERG
+#undef  printk_emerg
+#define printk_emerg(fmt, arg...)   do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_ALERT
+#undef  printk_alert
+#define printk_alert(fmt, arg...)   do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_CRIT
+#undef  printk_crit
+#define printk_crit(fmt, arg...)    do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_ERR
+#undef  printk_err
+#define printk_err(fmt, arg...)     do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_WARNING
+#undef  printk_warning
+#define printk_warning(fmt, arg...) do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_NOTICE
+#undef  printk_notice
+#define printk_notice(fmt, arg...)  do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_INFO
+#undef  printk_info
+#define printk_info(fmt, arg...)    do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_DEBUG
+#undef  printk_debug
+#define printk_debug(fmt, arg...)   do {} while(0)
+#endif
+#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_SPEW
+#undef  printk_spew
+#define printk_spew(fmt, arg...)    do {} while(0)
+#endif
+
+#define print_emerg(STR)   printk_emerg  ("%s", (STR))
+#define print_alert(STR)   printk_alert  ("%s", (STR))
+#define print_crit(STR)    printk_crit   ("%s", (STR))
+#define print_err(STR)     printk_err    ("%s", (STR))
+#define print_warning(STR) printk_warning("%s", (STR))
+#define print_notice(STR)  printk_notice ("%s", (STR))
+#define print_info(STR)    printk_info   ("%s", (STR))
+#define print_debug(STR)   printk_debug  ("%s", (STR))
+#define print_spew(STR)    printk_spew   ("%s", (STR))
+
+#define print_emerg_char(CH)   printk_emerg  ("%c", (CH))
+#define print_alert_char(CH)   printk_alert  ("%c", (CH))
+#define print_crit_char(CH)    printk_crit   ("%c", (CH))
+#define print_err_char(CH)     printk_err    ("%c", (CH))
+#define print_warning_char(CH) printk_warning("%c", (CH))
+#define print_notice_char(CH)  printk_notice ("%c", (CH))
+#define print_info_char(CH)    printk_info   ("%c", (CH))
+#define print_debug_char(CH)   printk_debug  ("%c", (CH))
+#define print_spew_char(CH)    printk_spew   ("%c", (CH))
+
+#define print_emerg_hex8(HEX)   printk_emerg  ("%02x",  (HEX))
+#define print_alert_hex8(HEX)   printk_alert  ("%02x",  (HEX))
+#define print_crit_hex8(HEX)    printk_crit   ("%02x",  (HEX))
+#define print_err_hex8(HEX)     printk_err    ("%02x",  (HEX))
+#define print_warning_hex8(HEX) printk_warning("%02x",  (HEX))
+#define print_notice_hex8(HEX)  printk_notice ("%02x",  (HEX))
+#define print_info_hex8(HEX)    printk_info   ("%02x",  (HEX))
+#define print_debug_hex8(HEX)   printk_debug  ("%02x",  (HEX))
+#define print_spew_hex8(HEX)    printk_spew   ("%02x",  (HEX))
+
+#define print_emerg_hex16(HEX)   printk_emerg  ("%04x", (HEX))
+#define print_alert_hex16(HEX)   printk_alert  ("%04x", (HEX))
+#define print_crit_hex16(HEX)    printk_crit   ("%04x", (HEX))
+#define print_err_hex16(HEX)     printk_err    ("%04x", (HEX))
+#define print_warning_hex16(HEX) printk_warning("%04x", (HEX))
+#define print_notice_hex16(HEX)  printk_notice ("%04x", (HEX))
+#define print_info_hex16(HEX)    printk_info   ("%04x", (HEX))
+#define print_debug_hex16(HEX)   printk_debug  ("%04x", (HEX))
+#define print_spew_hex16(HEX)    printk_spew   ("%04x", (HEX))
+
+#define print_emerg_hex32(HEX)   printk_emerg  ("%08x", (HEX))
+#define print_alert_hex32(HEX)   printk_alert  ("%08x", (HEX))
+#define print_crit_hex32(HEX)    printk_crit   ("%08x", (HEX))
+#define print_err_hex32(HEX)     printk_err    ("%08x", (HEX))
+#define print_warning_hex32(HEX) printk_warning("%08x", (HEX))
+#define print_notice_hex32(HEX)  printk_notice ("%08x", (HEX))
+#define print_info_hex32(HEX)    printk_info   ("%08x", (HEX))
+#define print_debug_hex32(HEX)   printk_debug  ("%08x", (HEX))
+#define print_spew_hex32(HEX)    printk_spew   ("%08x", (HEX))
+
+
Index: src/arch/i386/lib/printk_init.c
===================================================================
--- src/arch/i386/lib/printk_init.c.orig
+++ src/arch/i386/lib/printk_init.c
@@ -21,12 +21,23 @@ int console_loglevel = DEFAULT_CONSOLE_L
 
 extern int vtxprintf(void (*)(unsigned char), const char *, va_list);
 extern void uart8250_tx_byte(unsigned, unsigned char);
+#if CONFIG_USBDEBUG_DIRECT
+extern void usbdebug_direct_tx_byte(unsigned char);
+extern void usbdebug_direct_ram_tx_byte(unsigned char);
+#endif
 
 void console_tx_byte(unsigned char byte)
 {
-	if (byte == '\n')
+	if (byte == '\n') {
 		uart8250_tx_byte(TTYS0_BASE, '\r');
+#if CONFIG_USBDEBUG_DIRECT
+		usbdebug_direct_tx_byte('\r');
+#endif
+	}
 	uart8250_tx_byte(TTYS0_BASE, byte);
+#if CONFIG_USBDEBUG_DIRECT
+	usbdebug_direct_tx_byte(byte);
+#endif
 }
 
 int do_printk(int msg_level, const char *fmt, ...)
@@ -44,3 +55,31 @@ int do_printk(int msg_level, const char 
 
 	return i;
 }
+#if CONFIG_USBDEBUG_DIRECT
+void console_ram_tx_byte(unsigned char byte)
+{
+	if (byte == '\n') {
+		uart8250_tx_byte(TTYS0_BASE, '\r');
+		usbdebug_direct_ram_tx_byte('\r');
+	}
+	uart8250_tx_byte(TTYS0_BASE, byte);
+	usbdebug_direct_ram_tx_byte(byte);
+}
+
+int do_printk_ram(int msg_level, const char *fmt, ...)
+{
+	va_list args;
+	int i;
+
+	if (msg_level >= console_loglevel) {
+		return 0;
+	}
+
+	va_start(args, fmt);
+	i = vtxprintf(console_ram_tx_byte, fmt, args);
+	va_end(args);
+
+	return i;
+}
+#endif
+
Index: src/drivers/generic/debug/debug_dev.c
===================================================================
--- src/drivers/generic/debug/debug_dev.c.orig
+++ src/drivers/generic/debug/debug_dev.c
@@ -5,6 +5,7 @@
 #include <device/pci_ids.h>
 #include <device/pci_ops.h>
 #include <cpu/x86/msr.h>
+#include <arch/io.h>
 #include "chip.h"
 
 static void print_pci_regs(struct device *dev)
@@ -21,17 +22,53 @@ static void print_pci_regs(struct device
       printk_debug("\n");
 }
 
-static void print_mem(void)
+static void print_mem(unsigned start, unsigned size)
 {
         unsigned int i;
-	unsigned int start = 0xfffff000;
-	for(i=start;i<0xffffffff;i++) {
-             if((i & 0xf)==0) printk_debug("\n %08x:",i);
+	unsigned int end = start + size;
+	for(i=start; i<end; i++) {
+             if((i & 0xf)==0) printk_debug("\n%08x:",i);
              printk_debug(" %02x",(unsigned char)*((unsigned char *)i));
-             }
-	printk_debug(" %02x\n",(unsigned char)*((unsigned char *)i));
+	}
+	printk_debug("\n");
+
+}
+
+static void print_io(unsigned port)
+{
+
+        int i;
+        printk_debug("%04x:\n", port);
+        for(i=0;i<256;i++) {
+                uint8_t val;
+                if ((i & 0x0f) == 0) {
+                        printk_debug("%02x:", i);
+                }
+                val = inb(port);
+                printk_debug(" %02x",val);
+                if ((i & 0x0f) == 0x0f) {
+                        print_debug("\n");
+                }
+                port++;
+        }
+}
+
+static void print_io_mcp55(void)
+{
+	device_t dev;
+	struct resource *res;
+	int i;
+	dev= dev_find_slot(0, PCI_DEVFN(1, 1));
+	if(dev) {
+		for(i=0x68; i>0x60; i-=4) {
+			res = find_resource(dev, i);
+			if(res) {
+				print_io(res->base);
+			}
+		}
+	}
+}
 
- }
 static void print_pci_regs_all(void)
 {
         struct device *dev;
@@ -57,6 +94,60 @@ static void print_pci_regs_all(void)
 	}
 }
 
+static void print_pci_regs_index(struct device *dev, unsigned index_reg, unsigned type, unsigned length)
+{
+        int i;
+        printk_debug("%s\n", dev_path(dev));
+
+        printk_debug(" index reg: %04x type: %02x\n", index_reg, type);
+
+        type<<=28;
+
+        for(i = 0; i < length; i++) {
+                uint32_t val;
+                if ((i & 0x0f) == 0) {
+                        printk_debug("\n%02x:",i);
+                }
+	        pci_write_config32(dev, index_reg, i|type);
+	        val = pci_read_config32(dev, index_reg+0x4);
+
+                printk_debug(" %08x", val);
+        }
+        print_debug("\n");
+}
+#if 0
+static  void print_pci_regs_index_all_k9(void)
+{
+	int nodes = 64;
+	int i;
+	
+	device_t dev[64];
+	
+	for(i=0; i<nodes; i++) {
+		dev[i] = get_node_pci(i, 1);
+	}
+	printk_debug("MMIO:\n");
+	//MMIO
+	for(i=0; i<nodes; i++) {
+		if(!dev[i]) break;
+		print_pci_regs_index(dev[i], 0x110,2, 64);  
+		print_pci_regs_index(dev[i], 0x110,3, 64);  
+	}
+	//IO
+	printk_debug("MMIO:\n");
+	for(i=0; i<nodes; i++) {
+		if(!dev[i]) break;
+		print_pci_regs_index(dev[i], 0x110,4, 64);  
+	}
+	//DRAM
+	printk_debug("DRAM:\n");
+	for(i=0; i<nodes; i++) {
+		if(!dev[i]) break;
+		print_pci_regs_index(dev[i], 0x110,0, 64);  
+		print_pci_regs_index(dev[i], 0x110,1, 64);  
+	}
+}
+#endif
 static void print_cpuid()
 {
 	msr_t msr;
@@ -251,7 +342,13 @@ static void debug_init(device_t dev)
 		print_pci_regs_all();
 		break;
 	case 2: 
-		print_mem();
+		print_mem(0xffe00000, 0x100);
+		print_mem(0xfff00000, 0x100);
+		print_mem(0xfff80000, 0x100);
+		print_mem(0xfff90000, 0x100);
+		print_mem(0xfffa0000, 0x100);
+		print_mem(0xfffb0000, 0x100);
+		print_mem(0xfffc0000, 0x100);
 		break;
 	case 3:
 		print_cpuid();
@@ -271,6 +368,12 @@ static void debug_init(device_t dev)
 	case 8: 
 		hard_reset();
 		break;
+	case 9: 
+		print_io_mcp55();
+		break;
+	case 10: 
+	//	print_pci_regs_index_all_k9();
+		break;
 	}
 }
 
